<?php
/*
 * 这个API支持通过post请求添加数据，也支持通过post发送json数据进行修改和删除数据
 */
include_once '..\config\dbconfig.php';
/** @var mysqli $mysqli */

if (isset($_POST['add'])) {
    $bookname = $_POST['bookname'];
    $price = $_POST['price'];
    $pubdate = $_POST['pubdate'];
    $sort = $_POST['sort'];

    $stmt = $mysqli->stmt_init();
    $stmt->prepare('insert into tb_demo02 (bookname, price, f_time, type) values (?, ?, ?, ?)');
    $stmt->bind_param('siss', $bookname, $price, $pubdate, $sort);
    $stmt->execute();
    if ($stmt->affected_rows > 0) {
        echo '<script>alert("成功");location.href="../18.test3.result.php";</script>';
    } else {
        echo '<script>alert("添加失败");history.back();</script>';
    }
    $stmt->free_result();
    $stmt->close();
} else { // 原来是判断post请求中的update属性，想了下数据不在那里面...
    $data = json_decode(file_get_contents('php://input'), true);
    if (isset($data['update']) && $data['update']) {
        $stmt = $mysqli->stmt_init();
        $stmt->prepare('update tb_demo02 set bookname = ?, price = ?, f_time = ?, type = ? where id = ?');
        $stmt->bind_param('sissi', $data['bookname'], $data['price'], $data['f_time'], $data['type'], $data['id']);
        $stmt->execute();
        if ($stmt->affected_rows > 0) {
            echo json_encode(['message' => '修改成功']);
        } else {
            echo json_encode(['message' => '修改失败']);
        }
        $stmt->free_result();
        $stmt->close();
    } elseif (isset($data['delete']) && $data['delete']) {
        $stmt = $mysqli->stmt_init();
        $stmt->prepare('delete from tb_demo02 where id = ?');
        $stmt->bind_param('i', $data['id']);
        $stmt->execute();
        if ($stmt->affected_rows > 0) {
            echo json_encode(['message' => '删除成功']);
        } else {
            echo json_encode(['message' => '删除失败']);
        }
        $stmt->free_result();
        $stmt->close();
    }elseif (isset($data['batDelete']) && $data['batDelete']) {
        $stmt = $mysqli->stmt_init();
        $stmt->prepare('delete from tb_demo02 where id = ?');
        $ids = $data['id'];
        $count = 0;
        foreach ($ids as $id) {
            $stmt->bind_param('i', $id);
            $stmt->execute();
            if ($stmt->affected_rows > 0) {
                $count++;
            }
        }
        if ($count === count($ids)) {
            echo json_encode(['message' => '删除成功']);
        } else {
            echo json_encode(['message' => '删除失败']);
        }
        $stmt->free_result();
        $stmt->close();
    }
    else {
        echo json_encode(['message' => '异常操作']);
    }
}