<?php
/*
 * 这个API支持通过post请求添加数据，也支持通过post发送json数据进行修改和删除数据
 * 使用pdo代替mysqli
 */
include_once '../config/pdo_connect_db18.php';
/** @var PDO $pdo */

if (isset($_POST['add'])) {
    $bookname = $_POST['bookname'];
    $price = $_POST['price'];
    $pubdate = $_POST['pubdate'];
    $sort = $_POST['sort'];

    $stmt = $pdo->prepare('insert into tb_demo02 (bookname, price, f_time, type) values (?, ?, ?, ?)');
    $stmt->execute([$bookname, $price, $pubdate, $sort]);
    if ($stmt->rowCount() > 0) {
        echo '<script>alert("成功");location.href="../19.work3.result.php";</script>';
    } else {
        echo '<script>alert("添加失败");history.back();</script>';
    }
    $stmt->closeCursor();
} else { // 原来是判断post请求中的update属性，想了下数据不在那里面...
    $data = json_decode(file_get_contents('php://input'), true);
    if (isset($data['update']) && $data['update']) {
        $stmt = $pdo->prepare('update tb_demo02 set bookname = ?, price = ?, f_time = ?, type = ? where id = ?');
        $stmt->execute([$data['bookname'], $data['price'], $data['f_time'], $data['type'], $data['id']]);
        if ($stmt->rowCount() > 0) {
            echo json_encode(['message' => '修改成功']);
        } else {
            echo json_encode(['message' => '修改失败']);
        }
        $stmt->closeCursor();
    } elseif (isset($data['delete']) && $data['delete']) {
        $stmt = $pdo->prepare('delete from tb_demo02 where id = ?');
        $stmt->execute([$data['id']]);
        if ($stmt->rowCount() > 0) {
            echo json_encode(['message' => '删除成功']);
        } else {
            echo json_encode(['message' => '删除失败']);
        }
        $stmt->closeCursor();
    } elseif (isset($data['batDelete']) && $data['batDelete']) {
        $stmt = $pdo->prepare('delete from tb_demo02 where id = ?');
        $ids = $data['id'];
        $count = 0;
        foreach ($ids as $id) {
            $stmt->execute([$id]);
            if ($stmt->rowCount() > 0) {
                $count++;
            }
        }
        if ($count === count($ids)) {
            echo json_encode(['message' => '删除成功']);
        } else {
            echo json_encode(['message' => '删除失败']);
        }
        $stmt->closeCursor();
    } else {
        echo json_encode(['message' => '异常操作']);
    }
}